/* 
 * File:   i2cIMU.h
 * Author: Ashley, Adam, Jessica
 *
 * Created on November 26, 2016, 11:23 PM
 */

/* Acceleration data register */
#define DEVICE_ADDRESS 0x28

#define ACCEL_DATA_X_LSB_ADDR 0x08
#define ACCEL_DATA_X_MSB_ADDR 0x09
#define ACCEL_DATA_Y_LSB_ADDR 0x0A
#define ACCEL_DATA_Y_MSB_ADDR 0x0B
#define ACCEL_DATA_Z_LSB_ADDR 0x0C
#define ACCEL_DATA_Z_MSB_ADDR 0x0D

/* Gyro data registers */
#define GYRO_DATA_X_LSB_ADDR 0x14
#define GYRO_DATA_X_MSB_ADDR 0x15
#define GYRO_DATA_Y_LSB_ADDR 0x16
#define GYRO_DATA_Y_MSB_ADDR 0x17
#define GYRO_DATA_Z_LSB_ADDR 0x18
#define GYRO_DATA_Z_MSB_ADDR 0x19

/* Euler data registers */
#define EULER_YAW_LSB_ADDR   0x1A
#define EULER_YAW_MSB_ADDR   0x1B
#define EULER_ROLL_LSB_ADDR  0x1C
#define EULER_ROLL_MSB_ADDR  0x1D
#define EULER_PITCH_LSB_ADDR 0x1E
#define EULER_PITCH_MSB_ADDR 0x1F

#define OPR_MODE_ADDR 0x3D
#define PWR_MODE_ADDR 0x3E

#define OPERATION_MODE_CONFIG        0x00
#define OPERATION_MODE_ACCONLY       0x01
#define OPERATION_MODE_MAGONLY       0x02
#define OPERATION_MODE_GYRONLY       0x03
#define OPERATION_MODE_ACCMAG        0x04
#define OPERATION_MODE_ACCGYRO       0x05
#define OPERATION_MODE_MAGGYRO       0x06
#define OPERATION_MODE_AMG           0x07
#define OPERATION_MODE_IMUPLUS       0x08
#define OPERATION_MODE_COMPASS       0x09
#define OPERATION_MODE_M4G           0x0A
#define OPERATION_MODE_NDOF_FMC_OFF  0x0B
#define OPERATION_MODE_NDOF          0x0C

void configIMU(unsigned char mode);
signed char i2c1Read(unsigned char addr);
signed short i2c1ConsecutiveRead(unsigned char startReg, unsigned char num);