/* Based on DHTServer, ESP8266Webserver, DHTexample, and BlinkWithoutDelay
   ECE 4760: Vaidehi Garg (vg254), Divya Gupta (dg524), Vidya Ramesh (vr236)
*/

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>

const char* ssid       = "Your network";
const char* password   = "Your password";

ESP8266WebServer server(80);

// String to display
String webString;
String readString;

// Variables that store time are stored in unsigned longs
unsigned long previousMillis = 0;        // will store last temp was read
const long interval = 2000;              // interval at which to read sensor
 
void handle_root() {
  server.send(200, "text/plain", "Welcome to ECE4760 Borkbit, read from /borkbit");
  delay(100);
}

char buf[256];
int TIME = 0;
int LONG = 0;
int LAT = 0;
int VEL = 0;
float longitude;
float longitude2;
float latitude2;
float latitude;
float velocity;

float longitude_f;
float latitude_f;
float velocity_f;

void getSerial() {
  int i = 0;
  while (Serial.available() > 0 && i < 256) {
    char val = Serial.read(); //get one byte from serial buffer
    if (val == '\n') {
      buf[i] = 0;
      break;
    }
    else {
      readString += val;        //append byte to readString
      buf[i] = val;
    }
    delay(2);
    i++;
  }

    if (buf[0]=='L' && buf[1]=='A' && buf[2]=='T'){
    LAT = 1;
      latitude = (buf[4]-'0') * 10;
      latitude += (buf[5]-'0');
      latitude2 = (buf[7]-'0') *1000;
      latitude2 += (buf[8]-'0') *100;
      latitude2 += (buf[9]-'0') *10;
      latitude2 += (buf[10]-'0') ;
  }  

  if (LAT == 1){
      i = 0;
      while (Serial.available() > 0 && i < 256) {
        char val = Serial.read(); //get one byte from serial buffer
        if (val == '\n') {
          buf[i] = 0;
          break;
        }
        else {
          readString += val;        //append byte to readString
          buf[i] = val;
        }
        delay(2);
        i++;
      }
      
      if (buf[0]=='L' && buf[1]=='O' && buf[2]=='N' && buf[3]=='G'){
        LONG = 1;
        longitude = (int)(buf[5]-'0') * 10.0;          
        longitude += (int)(buf[6]-'0');
        longitude2 += (int)(buf[8]-'0') * 1000;
        longitude2 += (int)(buf[9]-'0') * 100;
        longitude2 += (int)(buf[10]-'0') * 10;
        longitude2 += (int)(buf[11]-'0') ;
        latitude_f = latitude;
        longitude_f = longitude;
        Serial.println(latitude);                   
        Serial.println(longitude)  ;    
      }
  }
  else {
    latitude = 0;
    LAT = 0;
  }

  if (buf[0]=='V' && buf[1]=='E' && buf[2]=='L'){
    VEL = 1;
    if (isdigit(buf[4])) velocity += (int)(buf[4]-'0');
    if (isdigit(buf[5])) velocity += (int)(buf[5]-'0') /10.0;
    if (isdigit(buf[6])) velocity += (int)(buf[6]-'0') /100.0;
    if (isdigit(buf[7])) velocity += (int)(buf[7]-'0') /1000.0;
    Serial.println(velocity); 
    velocity_f = velocity;                  
  } 
  else{
    VEL = 0;
    velocity = 0;
  }

  if (readString.length() > 0) {
    Serial.println(buf);
    readString = "";
  }
}

float try_lat = 42.4534;
float try_long = -76.4735;
String makeMap(){
  String gmap = "<html><body><h1>Borkbit: Where's My Dog?</h1><div id='map' style='width:100%;height:500px'></div>";
  gmap += "<script> function myMap() {";
  //gmap += "var newLocation = new google.maps.LatLng(52.508742,-0.121850);";
  gmap += "var newLocation = new google.maps.LatLng(";
  gmap += String((int)latitude);
  gmap += ".";
  gmap += String((int)latitude2);
  gmap += ",";
  gmap += "-";
  gmap += String((int)longitude);
  gmap += ".";
  gmap += String((int)longitude2);  
  gmap += ");";
  gmap += "var mapCanvas = document.getElementById('map');";
  gmap += "var mapOptions = {center: newLocation, zoom: 18};";
  gmap += "var map = new google.maps.Map(mapCanvas, mapOptions);";
  gmap += "var marker2 = new google.maps.Marker({position:newLocation});";
  gmap += "marker2.setMap(map); } </script>";
  gmap += "<script src='https:/";
  gmap += "/maps.googleapis.com/maps/api/js?key=AIzaSyADCj1mXE1ktbh-3TREbvWeii0QzTzIrrs&callback=myMap'></script>";
  gmap += "</body></html>";
  Serial.println(latitude);
  Serial.println(longitude);
  return gmap;
}
 
void setup(void)
{
  Serial.begin(9600);

  // Connect to WiFi network
  WiFi.begin(ssid, password);
  Serial.print("Connecting to wifi...");

  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  
  Serial.println("");
  Serial.println("ECE 4760 Borkbit Server");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
   
  server.on("/", handle_root);
  
  server.on("/borkbit", [](){
    getSerial();
    webString = "Long: "+String(longitude_f) + "\n";//+":"+String(buf);
    webString += "Lat: "+String(latitude_f)+ "\n";//+":"+String(buf);   
    webString += "Vel: "+String(velocity_f)+ "\n";//+":"+String(buf);
    LAT = 0;
    LONG = 0;
    VEL = 0;
    server.send(200, "text/plain", webString);  // send to browser when asked
    memset(buf, 0, sizeof buf);
  });

  server.on("/map", [](){
    server.send(200, "text/html", makeMap());  // send to browser when asked
  });
  
  server.begin();
  Serial.println("HTTP server started");
}
 
void loop(void)
{
  server.handleClient();
}
